# my_func (T. Chateau)
import numpy as np
import matplotlib
matplotlib.use('agg')
from matplotlib import pyplot as plt
import matplotlib.patches as patches
import cv2
import pdb
def fig2data(fig):
  fig.canvas.draw()
  w,h = fig.canvas.get_width_height()
  buf = np.fromstring(fig.canvas.tostring_argb(), dtype = np.uint8)
  buf.shape = (h,w,4)
  buf = buf[:,:,1:4]
  return buf
def display(part,X,im,disp_part=False):
  fig = plt.figure()
  axe1 = fig.add_subplot(121)
  axe2 = fig.add_subplot(122)
  im = cv2.cvtColor(im,cv2.COLOR_BGR2RGB) 
  axe1.imshow(im)
  # plot rectangles (part and est)
  if disp_part==True:
    for i in range(part.shape[0]):
      rect = patches.Rectangle((part[i,0],part[i,1]),part[i,2],part[i,3],linewidth=1,edgecolor='r',facecolor='none')
      axe1.add_patch(rect)
    pdb.set_trace
  rect = patches.Rectangle((X[0],X[1]),X[2],X[3],linewidth=2,edgecolor='r',facecolor='none')
  axe1.add_patch(rect)
  print('X = ',X)
  #_ = axe.hist(X[:,0], bins='auto')
  _ = axe2.hist(part[:,0], range = (0,im.shape[1]), bins='auto')
  #axe2.hist2d(part[:,0],part[:,1],bins=100,range = [[0,im.shape[1]],[0,im.shape[0]]])
  implot = fig2data(fig)
  implot = cv2.cvtColor(implot,cv2.COLOR_RGB2BGR)
  return implot
def display_opencv(im,part,X):
  #Display parts
  Nbp = part.shape[0]
  for i in range(Nbp):
    width = int(part[i,2])
    height = int(part[i,3])
    im = cv2.rectangle(im,(int(part[i,0]),int(part[i,1])),(int(part[i,0]+width),int(part[i,1]+height)),(0,255,0),1)
  im = cv2.rectangle(im,(int(X[0]),int(X[1])),(int(X[0]+width),int(X[1]+height)),(0,0,255),2)
  return im
