#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Sep  9 08:36:33 2018
Visual Tracking with particle filter
@author: thierrychateau
"""
import cv2
import os
import my_func as mf
import numpy as np
import matplotlib
matplotlib.use('agg')
from matplotlib import pyplot as plt
from matplotlib.colors import ListedColormap
import pdb  #pdb.set_trace()
#import math # to check if nan
###
# Importance Resampling function
def IR(part,w): # Importance resampling
  w = w/sum(w)
  wcum = np.cumsum(w)
  wcum = wcum/(wcum[-1])
  alea = np.random.rand(len(w))
  newpart = np.zeros_like(part) 
  for i in range(len(w)):
    z = np.where(alea[i]<wcum)
    ind = z[0]
    ind = ind[0]
    newpart[i,:]=part[ind,:]
  return newpart
###
# Prediction Function
def predict(part,im,bx=3,by=3,bw=0,bh=0):
  # size of image
  nbl = im.shape[0]
  nbc = im.shape[1]
  # Random step
  #### TO BE COMPLETED BY STUDENT
  return part 
###
# Compute histogram
def featureHist(pa,im,nbin=16):
    roi = im[int(pa[1]):int(pa[1]+pa[3]), int(pa[0]):int(pa[0]+pa[2]),:]
#    hist = cv2.calcHist([roi], [0, 1, 2], None, [8, 8, 8],
#         [0, 256, 0, 256, 0, 256]) #3-D RGB histogram
    hr = cv2.calcHist([roi],[0],None,[nbin],[0,256])
    hg = cv2.calcHist([roi],[1],None,[nbin],[0,256])
    hb = cv2.calcHist([roi],[2],None,[nbin],[0,256])
    h = np.concatenate((hr,hg,hb),axis = 0)
    return np.squeeze(h/sum(h))
###
# Likelihood function (compute weight for each particule)
def likelihood(part,im,model,la = 20):
  # la: lambda in w = exp(-lamdba*d) 
  w = []
  # Loop on particles
  for i in range(part.shape[0]):
    # Compute feature
    f = featureHist(part[i,:],im)
    # Calc Battacharya distance using opencv
    d = cv2.compareHist(f,model,cv2.HISTCMP_BHATTACHARYYA)
    w.append(np.exp(-la*d))
  return np.array(w)
def main():
  Basename = 'images/soccer_01/soccer'   #basename of image files
  #Basename = '/home/SCIENCES/thchatea/Public/Chateau/Datas/images_tracking_opencv/soccer_01/soccer'   #basename of image files
  ext = 'png' # extension used
  FirstImage = 1 # first image of the sequence
  LastImage = 135 # last  image of the sequence
  step = 1 #step between 2 images 
  first = True  
  Nbp = 200  #Nb of particles
  DISPLAY_OPENCV = True
  Pmem = []
  for i in range(FirstImage, LastImage,step):
    filename = "%s%0.5d.%s" % (Basename,i,ext)
    print(filename)
    im = cv2.imread(filename)
    if first:
      r = cv2.selectROI(im)
      # Init particles (state vector is x,y,width,height (top left of the roi). width and height are constant
      part = np.ones((Nbp,4))
      part[:,0] = part[:,0]*int(r[0])
      part[:,1] = part[:,1]*int(r[1])
      part[:,2] = part[:,2]*int(r[2])
      part[:,3] = part[:,3]*int(r[3])
      # Get model (crop image)
      hmodel = featureHist(part[0,:],im)
      first = False
    else:
      # Predict
      ### TO BE COMPLETED BY STUDENT 
      # Get weight (likelihooh function)
      ### TO BE COMPLETED BY STUDENT 
      w = .... 
      # normalize weight
      w = w/sum(w)
      # Importance resampling
      ### TO BE COMPLETED BY STUDENT 
      part = ....
      # Estimate state
      ### TO BE COMPLETED BY STUDENT 
      X = ....
      if DISPLAY_OPENCV:
        implot = mf.display_opencv(im, part, X)
      else:
        implot = mf.display(part,X,im)
      cv2.imshow('plot',implot)
      if cv2.waitKey(1) & 0xFF == ord('q'):
          break
    
if __name__ == "__main__":
    # execute only if run as a script
    main()
    

